Subject: RAID + LUKS exception, non-root device

From: "Nick Zalutskiy" <[email-masked]>
Date: Sun, 19 Dec 2021 09:52:37 -0500

Hello all,

I have the following configuration that results in an exception being thrown ("pre-mount actions failed") during boot after entering the LUKS password for the RAID array, which seems to assemble just fine in the prior step. I can also assemble this array, luksOpen, and mount just fine manually. See bellow and attached photo (sorry):

> (operating-system
>   ...
>   (initrd-modules (cons "raid0" %base-initrd-modules))
>   ...
>   (bootloader
>     (bootloader-configuration
>       (bootloader grub-efi-bootloader)
>       (target "/boot/efi")
>       (keyboard-layout keyboard-layout)))
>   (mapped-devices
>     (list (mapped-device
>             (source
>               (uuid "bdc2cdb8-f0df-46c9-994d-34ce101fc22a"))
>             (target "cryptroot")
>             (type luks-device-mapping))
>   (mapped-device
>     (source (list "/dev/nvme0n1" "/dev/nvme1n1" "/dev/nvme2n1" "/dev/nvme3n1"))
>     (target "/dev/md0")
>     (type raid-device-mapping))
>   (mapped-device
>     (source "/dev/md0")
>     (target "cryptraid0")
>     (type luks-device-mapping))))
>   (file-systems
>     (cons* (file-system
>              (mount-point "/")
>              (device "/dev/mapper/cryptroot")
>              (type "btrfs")
>              (dependencies mapped-devices))
>    (file-system
>              (mount-point "/raid0")
>              (device "/dev/mapper/cryptraid0")
>              (type "xfs")
>              (dependencies mapped-devices))
>            (file-system
>              (mount-point "/boot/efi")
>              (device (uuid "CBA2-3DD4" 'fat32))
>              (type "vfat"))
>            %base-file-systems)))

I'm also unable to reconfigure the system unless I already have the array mounted and luksOpened, so perhaps I'm doing this all wrong?

Thank you,

-Nick